package service;

import updateservice.service.UpdateServicePortType;
import updateservice.operations.UpdateResponse;
import updateservice.operations.Update;
import updateservice.shopping.ObjectFactory;

import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.xml.namespace.QName;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;
import java.lang.reflect.Method;

import org.w3c.dom.Element;

@WebService(name = "UpdateServicePortType",
            serviceName = "UpdateService",
            portName = "UpdateServicePort",
            targetNamespace = "urn:UpdateService:Service",
            wsdlLocation = "WEB-INF/wsdl/UpdateService.wsdl")
@SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
@XmlSeeAlso({
    updateservice.shopping.ObjectFactory.class,
    updateservice.operations.ObjectFactory.class
})
public class UpdateService implements UpdateServicePortType
{
  @Resource
  private EntityManager em;

  @Override
  public UpdateResponse update(
      @WebParam(name = "update",
                targetNamespace = "urn:UpdateService:Operations",
                partName = "parameters") Update parameters)
  {
    QName qname = parameters.getClassName();
    String xpath = parameters.getXpathValue();
    String[] paths = xpath.split("/");
    Element fragment = (Element) parameters.getAny();

    try
    {
      ObjectFactory of = new ObjectFactory();
      Class c = of.getClass(qname);
      if (c != null)
      {
        String[] keyValue = paths[0].split("=");

        // build a query based upon the input
        StringBuilder sb = new StringBuilder("SELECT object from ");
        sb.append(qname.getLocalPart());
        sb.append(" object ");
        sb.append("WHERE object.").append(keyValue[0]);
        sb.append(" = :").append(keyValue[0]);

        // execute the query
        Query query = em.createQuery(sb.toString());
        query.setParameter(keyValue[0], keyValue[1]);
        List tmpList = query.getResultList();

        // if the parameters did not define a unique instance, we may
        // get more than one instance back
        if (tmpList != null && !tmpList.isEmpty())
        {
          // for now, assume the keys defined a unique instance
          Object instance = tmpList.get(0);
          String[] classKeyValue = paths[1].split(":");
          String classname = classKeyValue[0];
          keyValue = classKeyValue[1].split("=");
          Method getMethod = c.getMethod("get" + classname);
          Object subInstance = getMethod.invoke(instance);
          // if the item to update was in a list, find the correct item
          if (subInstance instanceof List)
          {
            for (Object obj : (List) subInstance)
            {
              Method meth = obj.getClass().getMethod("get" + keyValue[0]);
              Object o = meth.invoke(obj);
              if (o.equals(keyValue[1]))
              {
                Method setMethod =
                    obj.getClass().getMethod("set" + fragment.getLocalName());
                setMethod.invoke(subInstance, fragment.getTextContent());
                break;
              }
            }
          }
          else
          {
            Method setMethod = subInstance.getClass()
                .getMethod("set" + fragment.getLocalName(), String.class);
            setMethod.invoke(subInstance, fragment.getTextContent());
          }

          // save the updated object back to the database
          em.persist(instance);
        }
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
      // TODO add a web exception if somethind went wrong
    }

    return new UpdateResponse();
  }
}
